module CourseraRb
  @@base_url = "https://api.coursera.org/api/catalog.v1"

  [:courses, :universities, :categories, :instructors, :sessions].each do |method_name|
    define_singleton_method method_name do |*args|
      query = {}

      if args[0]
        args[0].each{ |key, value| query[key] = value.is_a?(Array) ? value.join(',') : value }
      end

      response = HTTParty.get("#{ @@base_url }/#{ method_name }", { :query => query })
      JSON.parse(response.body)
    end
  end
end